# MySQL dump 8.16
#
# Host: localhost    Database: knowledgebase
#--------------------------------------------------------
# Server version	3.23.47

#
# Table structure for table 'base_keys'
#

CREATE TABLE base_keys (
  doc_key int(11) default NULL,
  keyword varchar(50) default NULL
) TYPE=MyISAM;

#
# Dumping data for table 'base_keys'
#

INSERT INTO base_keys VALUES (0,'test1');
INSERT INTO base_keys VALUES (0,'test2');
INSERT INTO base_keys VALUES (0,'test3');
INSERT INTO base_keys VALUES (0,'test4');
INSERT INTO base_keys VALUES (10,'URL rewriting');
INSERT INTO base_keys VALUES (10,'security');
INSERT INTO base_keys VALUES (7,'users');
INSERT INTO base_keys VALUES (7,'add');
INSERT INTO base_keys VALUES (4,'shared libraries');
INSERT INTO base_keys VALUES (4,'os');
INSERT INTO base_keys VALUES (4,'load');
INSERT INTO base_keys VALUES (12,'date');
INSERT INTO base_keys VALUES (12,'input');
INSERT INTO base_keys VALUES (12,'data entry');

#
# Table structure for table 'categories'
#

CREATE TABLE categories (
  category varchar(20) NOT NULL default '',
  description varchar(30) default NULL,
  PRIMARY KEY  (category)
) TYPE=MyISAM;

#
# Dumping data for table 'categories'
#

INSERT INTO categories VALUES ('Operating System','An operating system problem.');
INSERT INTO categories VALUES ('Software - Main','Main software group problem.');
INSERT INTO categories VALUES ('Component','Problem with software componen');
INSERT INTO categories VALUES ('Hardware','It\'s a hardware problem.');

#
# Table structure for table 'knowledge_base'
#

CREATE TABLE knowledge_base (
  doc_key int(11) NOT NULL auto_increment,
  doc_name varchar(50) default NULL,
  doc_location varchar(50) default NULL,
  level tinyint(11) NOT NULL default '0',
  category varchar(50) default NULL,
  post_user varchar(50) default NULL,
  date_submitted date default NULL,
  link_doc int(11) default NULL,
  base_doc_key tinyint(11) NOT NULL default '0',
  entry_date date default NULL,
  PRIMARY KEY  (doc_key,base_doc_key,level)
) TYPE=MyISAM;

#
# Dumping data for table 'knowledge_base'
#

INSERT INTO knowledge_base VALUES (4,'Problem with OS Load Operation','New Jersey',0,'Software - Main','art','2002-01-02',0,4,'0000-00-00');
INSERT INTO knowledge_base VALUES (6,'Problem with OS Load Operation','New Jersey',0,'Software - Main','art','2002-01-02',5,4,'0000-00-00');
INSERT INTO knowledge_base VALUES (5,'Problem with OS Load Operation','New Jersey',0,'Software - Main','art','2002-01-02',4,4,'0000-00-00');
INSERT INTO knowledge_base VALUES (7,'can\'t create new user','New Jersey',0,'Software - Main','art','2002-01-02',0,7,'0000-00-00');
INSERT INTO knowledge_base VALUES (8,'can\'t create new user','New Jersey',0,'Software - Main','art','2002-01-02',7,7,'0000-00-00');
INSERT INTO knowledge_base VALUES (9,'can\'t create new user','New Jersey',0,'Software - Main','art','2002-01-02',0,7,'0000-00-00');
INSERT INTO knowledge_base VALUES (10,'security failure','New Jersey',0,'Component','art','2001-11-20',0,10,'2001-11-20');
INSERT INTO knowledge_base VALUES (11,'security failure','New Jersey',0,'Software - Main','art','2001-11-20',10,10,'2001-11-20');
INSERT INTO knowledge_base VALUES (12,'date errors','New Jersey',0,'Software - Main','art','2002-03-11',0,12,'2002-03-11');

#
# Table structure for table 'knowledge_messages'
#

CREATE TABLE knowledge_messages (
  doc_key int(11) default NULL,
  message_txt varchar(200) default NULL,
  message_type varchar(10) default NULL
) TYPE=MyISAM;

#
# Dumping data for table 'knowledge_messages'
#

INSERT INTO knowledge_messages VALUES (0,'test','Problem');
INSERT INTO knowledge_messages VALUES (6,'also need to upgrade to 4.0.x version or later','Resolution');
INSERT INTO knowledge_messages VALUES (4,'There appears to be a problem when the OS load operation begins to look for shared libraries. 	','Problem');
INSERT INTO knowledge_messages VALUES (5,'Just move the shared libraries to /usr/share/coolproducts and the library will be loaded','Resolution');
INSERT INTO knowledge_messages VALUES (7,'user add feature sometimes seems to fail randomly','Problem');
INSERT INTO knowledge_messages VALUES (8,'don\'t add users','Resolution');
INSERT INTO knowledge_messages VALUES (9,'you can add users. just need to apply patch 4.5.33','Resolution');
INSERT INTO knowledge_messages VALUES (10,'session may be compromised by URL rewriting.','Problem');
INSERT INTO knowledge_messages VALUES (11,'need to switch to SSL to get proper security. otherwise the problem will persist.','Problem');
INSERT INTO knowledge_messages VALUES (12,'we seem to have a number of date errors during data entry.','Problem');

#
# Table structure for table 'message_security'
#

CREATE TABLE message_security (
  login varchar(20) NOT NULL default '',
  role varchar(10) default NULL,
  upd_date date default NULL,
  PRIMARY KEY  (login)
) TYPE=MyISAM;

#
# Dumping data for table 'message_security'
#

INSERT INTO message_security VALUES ('art','admin','0000-00-00');

#
# Table structure for table 'message_types'
#

CREATE TABLE message_types (
  message_type varchar(20) NOT NULL default '',
  description varchar(30) default NULL,
  PRIMARY KEY  (message_type)
) TYPE=MyISAM;

#
# Dumping data for table 'message_types'
#

INSERT INTO message_types VALUES ('Problem','Enter a problem description.');
INSERT INTO message_types VALUES ('Resolution','Enter a resolution to an exist');

#
# Table structure for table 'message_user'
#

CREATE TABLE message_user (
  login varchar(15) NOT NULL default '',
  first_name varchar(25) default NULL,
  last_name varchar(25) default NULL,
  location varchar(50) default NULL,
  date_submitted date default NULL,
  last_login date default NULL,
  pwd varchar(15) default NULL,
  PRIMARY KEY  (login)
) TYPE=MyISAM;

#
# Dumping data for table 'message_user'
#

INSERT INTO message_user VALUES ('art','Art','Taylor','New Jersey','2001-01-01','2002-03-12','yes');

#
# Table structure for table 'testit'
#

CREATE TABLE testit (
  col1 int(11) NOT NULL auto_increment,
  col2 int(11) default NULL,
  col3 char(20) default NULL,
  PRIMARY KEY  (col1)
) TYPE=MyISAM;

#
# Dumping data for table 'testit'
#

INSERT INTO testit VALUES (1,NULL,NULL);
INSERT INTO testit VALUES (2,NULL,NULL);

