package bind;

import javax.naming.InitialContext;
import javax.naming.Context;
import javax.naming.NamingException;
import java.util.Hashtable;
import java.rmi.RemoteException;

import chapter14.RemoteGeneralDAO;

public class BindRMIRegistry {

//
// bind org.gjt.mm.mysql.MySQLDataSource object into rmiregistry namespace 
//
public static void main( String args[] ) {

try {

System.out.println( "Creating DataSource object for movies ... " );
org.gjt.mm.mysql.MysqlDataSource mySQLDS = 
              new org.gjt.mm.mysql.MysqlDataSource();
mySQLDS.setUser( "art" );
mySQLDS.setPassword( "YES" );
mySQLDS.setServerName( "localhost" );
mySQLDS.setDatabaseName( "movies" );
mySQLDS.setPort( 3306 );

System.out.println( "Creating DataSource object for knowledgebase ... " );
org.gjt.mm.mysql.MysqlDataSource mySQLKB = 
              new org.gjt.mm.mysql.MysqlDataSource();
mySQLKB.setUser( "art" );
mySQLKB.setPassword( "YES" );
mySQLKB.setServerName( "localhost" );
mySQLKB.setDatabaseName( "knowledgebase" );
mySQLKB.setPort( 3306 );

// a test database 
org.gjt.mm.mysql.MysqlDataSource mySQLTest = 
              new org.gjt.mm.mysql.MysqlDataSource();
mySQLTest.setUser( "art" );
mySQLTest.setPassword( "YES" );
mySQLTest.setServerName( "localhost" );
mySQLTest.setDatabaseName( "test" );
mySQLTest.setPort( 3306 );

//
// jndi.properties contains the settings to establish the 
// initialcontext 
//
System.out.println( "Getting InitialContext ... " );


// 
// hardcode this to the RMI registry
// registry ({JAVA_HOME}/bin/rmiregistry) needs to be running
//
Hashtable env = new Hashtable();
env.put( "java.naming.factory.initial", 
         "com.sun.jndi.rmi.registry.RegistryContextFactory");
env.put( "java.naming.provider.url",
          "rmi://localhost:1099" );

InitialContext ctx = new InitialContext( env ); 

//
// bind our DataSource object into the registry 
// 
System.out.println( "Binding DataSources: moviesmysql, knowledgebase, test ... " ); 
ctx.unbind("movies");
ctx.bind("movies", mySQLDS);
ctx.unbind("knowledgebase");
ctx.bind("knowledgebase", mySQLKB);
ctx.unbind("test");
ctx.bind("test", mySQLTest);
System.out.println( "DataSources binding complete ... " ); 

//
// needed for the remote database table browser application in chapter14
//
RemoteGeneralDAO rgdo = new RemoteGeneralDAO();
// binding 
System.out.println( "Binding RemoteGeneralDAO ... " ); 
ctx.rebind( "remote_general_dao", rgdo );


ctx.close();
}
catch (NamingException e ) {
  System.out.println( "NamingException caught in main: " + e.getMessage() );
  System.out.println( "toString(): " + e );
}
catch (RemoteException e ) {
  System.out.println( "RemoteException caught in main: " + e.getMessage() );
  System.out.println( "toString(): " + e );
}

}  


}
