/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */

package chapter17;

import java.text.*;
import java.util.*;
import java.io.*;

import javax.servlet.*;
import javax.servlet.jsp.tagext.*;
import javax.servlet.jsp.*;

public class TagCal  extends TagSupport {

Cal cal;

int month;
int day;
int year;

private  boolean dateStringOnly;
private  String printHighLightColor = "grey";

public int doStartTag() {


if ( cal == null )
    cal = new Cal();

//
// no setters have been called so  
// use the current day as the default date
//
if ( ( month == 0 ) && ( day == 0 ) && ( year == 0 ) ) 
    cal.setCalCurrentDate();

//
// setters have been called, so set the calendar date accordingly 
//
if ( ( month != 0 ) && ( day != 0 ) && ( year != 0 ) ) {
//    month--; // GregorianCalendar expects 0 - based month
    cal.setCalDate( month, day, year );
}

//
// set the default output stream to the JspWriter in the pageContext
//
JspWriter out = pageContext.getOut();

//cal.setOut( out ); 
cal.setHighLightColor( printHighLightColor );

try {

// print the calendar 
if ( !dateStringOnly )  {
    cal.printCal( out );
}
else  {    // print the current date as a string 
   out.println( cal.getCurrentDate() );
   dateStringOnly = false;
}

}

catch (ServletException e) {
 
  System.out.println("TagCal error: " + e.getMessage() );

}
catch (IOException e) {
      System.out.println( "IOException in TagCal: " + e.getMessage() );
}


// the tag shouldn't have a body to process 
return (SKIP_BODY);
}



// ***************************************************
// Bean methods 


public void setMonth( int month ) {
  this.month = month;
}  


public void setYear( int year ) {
  this.year = year;
}

public void setDay( int day ) {
   this.day = day;
}

public void setHighLightColor ( String color ) {
  this.printHighLightColor = color;
}

public void setDateString( boolean flag ) {

   this.dateStringOnly = flag;

}

}
