
/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */


package chapter20;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.ResultSetMetaData;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.Writer;
import java.io.FileWriter;
import db.DBUtil;

public class JDBCXML {


public static void main( String args[] ){

try { 

DBUtil dbutil = new DBUtil("knowledgebase");

ResultSet rs = dbutil.executeDBQuery("select * from knowledge_base");

System.out.println( toXMLString( rs ) );

// write to a file 
rs.beforeFirst();
toXMLFile( rs, new FileWriter( "rsTest.xml" ));

}
catch (SQLException e) {
   System.err.println("SQLException: " + e.getMessage());
}
catch (IOException e) {
   System.err.println("IOException: " + e.getMessage());
}
catch (Exception e) {
   System.err.println("Exception: " + e.getMessage());
}

}



public static String toXMLString( ResultSet rs ) {
StringBuffer buffer = new StringBuffer(1024);

buffer.append( "<ResultSet>\n" );

try {

ResultSetMetaData rsmd  = rs.getMetaData();

while ( rs.next() ) {
buffer.append( "  <row>\n");
   for ( int n = 1; n <= rsmd.getColumnCount(); n++ ) {

       buffer.append( "   <Column>\n" );  
       //buffer.append( "     <Name>" + rsmd.getColumnName(n) + "</Name>\n" );
       //buffer.append( "     <Table>" + rsmd.getTableName(n) + "</Table>\n" );

       buffer.append( "     <Name>" ).append( rsmd.getColumnName(n) ).append( "</Name>\n" );
       buffer.append( "     <Table>" ).append( rsmd.getTableName(n) ).append( "</Table>\n" );
       buffer.append( "     <Type>" ).append( rsmd.getColumnTypeName(n) ).append( "</Type>\n" );
       
       //
       // must manage null object references
       //
       Object o = rs.getObject( n ); 
       if ( rs.wasNull() ) {
           buffer.append( "     <Data>null</Data>\n");
       }
       else {
           buffer.append("     <Data>").append(o.toString()).append("</Data>\n");

       }
       buffer.append( "   </Column>\n" );  

   } 
buffer.append( "  </row>\n");

}

buffer.append( "</ResultSet>\n" );

}
catch (SQLException e) {
       System.out.println( "SQLException thrown in toXMLString " + e.getMessage() );

}

finally {
if ( buffer != null ) 
   return buffer.toString();
else
   return null;
}


}

// ------------------------------------------------------------------------------

public static void toXMLFile( ResultSet rs, Writer writer ) {
//StringBuffer buffer = new StringBuffer();

try { 

BufferedWriter out = new BufferedWriter( writer );

//
// write the XML document to the output stream and close it
// 
out.write( toXMLString( rs ) );
out.close();

}
catch (IOException e) {
       System.out.println( "IOException thrown in toXMLString " + e.getMessage() );

}


}


}
