
/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */


package chapter20;

import java.io.*;

import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import java.sql.*;
import javax.sql.*;
import java.net.*;
import java.io.*;
import org.xml.sax.*;
import javax.naming.*;
import java.rmi.*;
import db.*;
import jdbcutil.*;
import movies.ejb.*;
import com.icl.saxon.trax.*;

public class ServletExample1 extends HttpServlet {

ServletConfig      config;
ServletContext     context;

MoviesFacadeRemote moviesEJB;

//
// for Saxon XML transformations
//
Processor   processor;
Templates   templates;
Transformer transformer;

PreparedStatement pstmt;
Connection con;

String           defaultStyleSheet = "file:/lin/home/art/JDBC_Real/Code/Dynamic/rs.xsl";



    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
        PrintWriter out = response.getWriter();

        out.println("<html>");
        out.println("<head>");

	out.println("<title>Movies Listing</title>");
        out.println("</head>");
        out.println("<body bgcolor=\"white\">");


        try { 

          if ( pstmt == null ) {                          // need to prepare the query 
	      //
	      // get the query from an environment parameter 
	      //
	      String query = context.getInitParameter( "Query2" );

              //
	      // prepare the query 
	      //
	      pstmt = con.prepareStatement( query );

              //
	      // return an XML encoded string with the results 
	      //
	  }

	  //
	  // execute the prepared query and retrieve the results
	  // results are formatted as an XML document 
	  //
	  String xmlDoc = getQueryResults();

          //
          // transform the XML to the format for our output (an HTML table)
	  //
	  //Transformer transformer = templates.newTransformer();
          transformer.transform(  new InputSource( new StringReader( xmlDoc ) ),
	                          new Result( out ) ); 

           out.println("</body>");
           out.println("</html>");
        }
	catch (Exception e) { 
              log( "Exception in doGet: " + e.getMessage() );
	}
      
      }
// -----------------------------------------------------------------------

public String getQueryResults() {
ResultSet rs = null;
try {
       rs = pstmt.executeQuery( ); 

}
catch (SQLException e) {
       //context.log("RemoteException in ServletExample2.getQueryResults: " + e.getMessage() );
       System.out.println("SQLException in ServletExample2.getQueryResults: " + e.getMessage() );
}
finally {
     return JDBCXML.toXMLString( rs );
}

}

// -----------------------------------------------------------------------
public void init( ServletConfig config ) {

// ** delete ** 
//Hashtable env = new Hashtable();

         this.config = config;
	 this.context = config.getServletContext();

	  //
	  // get the location of the xslt stylesheet from a context parameter
	  //
	  String styleSheet = context.getInitParameter( "XsltQuery2" );

try {
	  //
	  // build the URL for the stylesheet 
	  //
	  if ( styleSheet == null ) 
	      styleSheet = defaultStyleSheet;
          else
	      styleSheet = "file:" + styleSheet;

          // 
	  // create the objects we need for the XSL transformation 
	  //
	  processor = Processor.newInstance("xslt");
	  // get an InputStream from the URL 
	  // does InputSource constructor support URL encoded string ?? 
	  //templates = processor.process(new InputSource( styleSheet ) ); 
          //
	  templates = processor.process(new InputSource( 
	                  new URL( styleSheet ).openStream() ) );

	  transformer = templates.newTransformer();

          //
	  // prepare data access
	  //
          InitialContext init = new InitialContext( );

          //
	  // tomcat 4.02 requires a two step lookup 
	  //
          Context ctx   = (Context) init.lookup( "java:comp/env/jdbc" );
	  DataSource ds = (DataSource) ctx.lookup( "moviesmysql" );

	  con = ds.getConnection();

//debug
System.out.println("init processing complete. Have connection ... ");

}
catch (SQLException e) {
       System.out.println("SQLException in ServletExample2.init: " + e.getMessage() );
}
catch (ProcessorException e) {
       System.out.println("ProcessorException in ServletExample2.init: " + e.getMessage() );
}
catch (RemoteException e) {
       System.out.println("RemoteException in ServletExample2.init: " + e.getMessage() );
}
catch (NamingException e) {
       System.out.println("NamingException in ServletExample2.init: " + e.getMessage() + " - " + e );
}
catch (Exception e) {
       System.out.println("Exception in ServletExample2.init: " + e.getMessage() );
}


}
// ---------------------

}



