

/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */


package chapter21;

import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.OutputStream;
import java.io.IOException;

import movies.blobs.BlobWriter;

public class BlobView extends HttpServlet {

private BlobWriter blobwriter;

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {

        // 
        // get the output stream for our response
	// 
	OutputStream out = response.getOutputStream();

        //
	// set the content type for our graphic file to return 
	//
        response.setContentType("image/jpeg");

        try { 

            //
            // this will retrieve the Blob referenced by the movie_id
	    // and write it to the OutputStream parameter passed in 
	    //
	    blobwriter.getBlob( Integer.parseInt( request.getParameter( "movie_id" ) ), out );

        }
	catch (Exception e) { 
              log( "Exception in doGet: " + e.getMessage() );
	}
      
    }

// -----------------------------------------------------------------------
public void init( ) {

   //
   // BlobWriter will open the connection and create 
   // a PreparedStatement to perform the database i/o
   //
   String dataSourceName = getInitParameter( "data-resource-name" ); 
   blobwriter = new BlobWriter( dataSourceName );


}
// ------------------------------------------------------------------------

}



