/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */


package chapter3;

import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.SQLException;
import java.sql.Connection;
import java.sql.DriverManager;

public class JDBCExample1 {


public static void main( String args[] ) {

//
//  a PostgreSQL connection string 
//
//
//String connectionURL = 
//       "jdbc:postgresql://localhost:5432/movies;user=puser;password=puser";


// 
// if not using a DataSource, should load these parameters from a properties 
// file or using some other dynamic mechanism
//
String connectionURL = 
       "jdbc:mysql://localhost/movies?user=art&password=YES";

String driver = "org.gjt.mm.mysql.Driver";


try { 

     //
     // load the Driver class 
     // 
     Class.forName( driver );

     //
     // create the connection using the static getConnection method 
     // 
     Connection con = DriverManager.getConnection( connectionURL );

     Statement stmt = con.createStatement();

     //
     // execute the SQL statement and get the results in a ResultSet 
     //
     ResultSet rs   = stmt.executeQuery("select movie_name, release_date from movies" ); 

     //
     // iterate through the rows 
     //
     while ( rs.next() ) {
            System.out.println( "******************" + "\n" + 
	                        "movie_name: " + "\t" + rs.getString("movie_name") + "\n" + 
	                        "release_date: " + "\t" + rs.getString("release_date")  ); 
     }

    //
    // close the connection 
    //
    con.close(); 
				
}
catch (SQLException e) {
     // display SQL specific exception information 
     System.out.println("*************************" );
     System.out.println("SQLException in main: " + e.getMessage() );
     System.out.println("** SQLState: " + e.getSQLState());
     System.out.println("** SQL Error Code: " + e.getErrorCode());
     System.out.println("*************************" );
     e.printStackTrace();
}
catch (ClassNotFoundException e) {
     System.out.println("*************************" );
     System.out.println("ClassNotFoundException in main: " + e.getMessage() );
     System.out.println("*************************" );
     e.printStackTrace();
}


}

}
