
/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */


package chapter7;

import java.sql.Connection;
import java.sql.CallableStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.DatabaseMetaData;
import javax.sql.DataSource;
import javax.naming.NamingException;
import javax.naming.InitialContext;

public class StoredProcExample1 {

public static void main( String args[] ) {


try { 

     // load the DataSource
     InitialContext ctx = new InitialContext();
     DataSource  ds   = (DataSource) ctx.lookup("movies");

     // create the connection using the static getConnection method 
     Connection con = ds.getConnection( );

     // create a Statement class to execute the SQL statement 
     Statement stmt = con.createStatement(); 


     DatabaseMetaData dmd = con.getMetaData();
     if ( dmd.supportsStoredProcedures() ) 
         System.out.println( "Database supports stored procedures.");
     else 
         System.out.println( "Database DOES NOT support stored procedures.");

     CallableStatement cs = con.prepareCall("{? = call get_movie('%Java%') }" ); 
     ResultSet rs = cs.executeQuery();


     // 
     // iterate through the ResultSet, displaying two values 
     // for each row using the getString method  
     // 
     while ( rs.next() ) 
            System.out.println( rs.getString(1) + "\n" ); 
	                        

    // close the connection 
    con.close(); 
				
}
catch (SQLException e) {
     // display SQL specific exception information 
     System.out.println("*************************" );
     System.out.println("SQLException in main: " + e.getMessage() );
     System.out.println("** SQLState: " + e.getSQLState());
     System.out.println("** SQL Error Code: " + e.getErrorCode());
     System.out.println("*************************" );
     e.printStackTrace();
}
catch (Exception e) {
     e.printStackTrace();
}



}

}
