
/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */

package db;

import java.util.Vector;
import java.util.Hashtable;
import java.util.HashSet;
import java.io.Serializable;

public class GeneralAggregateVO implements GenericVO, Serializable {

// internal vectors 
private Vector    rows          = new Vector();  // stores and array of currentRecord vectors
private Vector    updateFlags   = new Vector();  // an update flag for each row 
private Vector    currentRecord = new Vector();  // the column values (object references) for the current record
private Hashtable updateCols    = new Hashtable(); // update row,cols that have been updated

// current position 
private int       currentRow    = 0;

// maintain counts 
private int       rowCount      = 0;
private int       columnCount   = 0;

// for column name mapping 
private Hashtable colKeys       = new Hashtable();
private Hashtable colNums       = new Hashtable();

public static void main( String args[] ) {

// create an object 
GeneralAggregateVO gvo = new GeneralAggregateVO();

System.out.println("Starting .... ");
System.out.println("Vector size : " + gvo.currentRecord.size() );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );
System.out.println("******************************");

// set the column keys for column name lookups
gvo.setColKey( "col1", 0 );
gvo.setColKey( "col2", 1 );
gvo.setColKey( "col3", 2 );

// add some data 
gvo.addObject("this");      // 0
gvo.addObject("that");      // 1
gvo.addObject("the other"); // 2

// add current row onto the end
gvo.addRow();

// print it 
System.out.println("******************************");
System.out.println("Data added ... " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );

// add some more data 
gvo.addObject("some");      // 0
gvo.addObject("more");      // 1
gvo.addObject("data"); // 2

// add row
gvo.addRow();

System.out.println("******************************");
System.out.println("Data added ... " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );


// add some more data 
gvo.addObject("fred");      // 0
gvo.addObject("is");      // 1
gvo.addObject("not here"); // 2

// add row
gvo.addRow();

System.out.println("******************************");
System.out.println("Data added ... " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );

// return it 
gvo.absolute(0);
System.out.println(" absolute(0) " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );
System.out.println( "1: " + gvo.getObject(0));
System.out.println( "2: " + gvo.getObject(1));
System.out.println( "3: " + gvo.getObject(2));

gvo.absolute(1);
System.out.println(" absolute(1) " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );
System.out.println( "1: " + gvo.getObject(0));
System.out.println( "2: " + gvo.getObject(1));
System.out.println( "3: " + gvo.getObject(2));

gvo.absolute(2);
System.out.println(" absolute(2) " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );
System.out.println( "1: " + gvo.getObject(0));
System.out.println( "2: " + gvo.getObject(1));
System.out.println( "3: " + gvo.getObject(2));

gvo.absolute(0);
System.out.println(" absolute(0) " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );
System.out.println("getObject('col1'): " + gvo.getObject("col1"));
System.out.println("getObject('col2'): " + gvo.getObject("col2"));
System.out.println("getObject('col3'): " + gvo.getObject("col3"));

gvo.absolute(1);
System.out.println(" absolute(1) " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );
System.out.println("getObject('col1'): " + gvo.getObject("col1"));
System.out.println("getObject('col2'): " + gvo.getObject("col2"));
System.out.println("getObject('col3'): " + gvo.getObject("col3"));

// change the contents 
gvo.absolute(2);
System.out.println(" absolute(2) " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );
gvo.setObject( "col1", "argghhh");
gvo.setObject( "col2", "oh no mr. bill");
gvo.setObject( "col3", "yechhh");

// print it 
gvo.absolute(2);
System.out.println(" absolute(2) " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );
System.out.println("getObject('col1'): " + gvo.getObject("col1"));
System.out.println("getObject('col2'): " + gvo.getObject("col2"));
System.out.println("getObject('col3'): " + gvo.getObject("col3"));

// deleteRow
gvo.absolute(1);
gvo.deleteRow();
System.out.println(" absolute(1) " );
System.out.println("deleteRow() " );
System.out.println("currentRow: " + gvo.getRowPos() );
System.out.println("rowCount: " + gvo.getRowCount() );
System.out.println("getObject('col1'): " + gvo.getObject("col1"));
System.out.println("getObject('col2'): " + gvo.getObject("col2"));
System.out.println("getObject('col3'): " + gvo.getObject("col3"));

// append a row 
gvo.appendRow();
System.out.println( "appended. rowpos: " + gvo.getRowPos() );

gvo.setObject(0,"this");      // 0
gvo.setObject(1,"was");      // 1
gvo.setObject(2,"appended"); // 2

if ( gvo.getInsertStatus( gvo.getRowPos() ) ) 
    System.out.println("this is an insert row.");
else
    System.out.println("this SHOULD BE an insert row.");

// iterate
gvo.dumpContents();


}


// ------------------------------------------------------------------


// set contents 

// set keys for colname to positional mapping 
public void setColKey( String name, int pos ) {

   // map column name to position 
   colKeys.put( name, new Integer( pos ) ); 
  
   // reverse map. for lookup position and match to name  
   colNums.put( new Integer( pos ), name ); 

   columnCount++;

}

public void setObject( int col, Object obj ) {

    currentRecord.set( col, obj );

}

public void setObject( String keyName, Object obj ) {

      int pos  = ((Integer) colKeys.get( keyName )).intValue();
      setObject( pos, obj );

}

// ------------------------------------------------------------------

public void addObject( Object obj ) {

    // will fail if we attempt to go beyond columnCount
    if ( currentRecord.size() <= columnCount ) {

        // add the object 
        currentRecord.add( obj );               

    }
    else
        System.out.println("Attempt to get beyond number of columns in VO.");

}
// ------------------------------------------------------------------

// add a vector to our current collection 

public void addRow( Vector v ) {


for (int n = 0; n < v.size(); n++ ) {
    addObject( v.get( n ) ); 
}
addRow();

}

// ------------------------------------------------------------------

// add the current VO to our rows 
public void addRow() {

     rows.add( (Object) currentRecord );

     // create a new row 
     updateFlags.add( new String( "" ) );     // null for 'no updates'
     currentRecord = new Vector();
     currentRow++;
     rowCount++;

}

// ------------------------------------------------------------------

// clear our current row
public void clearCurrentRow() {
     currentRecord.removeAllElements();
}

// ------------------------------------------------------------------
// delete our current row 
public void deleteRow() {
     rows.remove( currentRow );
     currentRow--;
     rowCount--;
}
// ------------------------------------------------------------------

// append a row onto the end of our data set 
// that row then becomes the current record
public void appendRow() {

// this is considered an 'insert' row. it will need to be placed into the 
// underlying database with an insert operation 


// add a 'blank' row that we later update
     // create a new row 

     updateFlags.add( new String( "" ) );     // this is an insert row 
     currentRecord = new Vector();

     // create empty object references 
     for ( int n = 0; n < getColumnCount(); n++ ) {
          addObject( "" );
     }

     rows.add( (Object) currentRecord );
     rowCount++;
     currentRow = rowCount - 1;                           // we are pointing at this row - the last row

     updateFlags.set( getRowPos(), new String( "I" )  );  // set the update flag for this row

}

// ------------------------------------------------------------------
// update - set flags to indicate update status  
public void updateObject( int col, Object value ) {
HashSet colSet     = null;
Integer rowPos     = new Integer( getRowPos() ); // current row position 

    // set the update flags
    if  ( !( getInsertStatus( getRowPos() )) )   {        // only set this if the 'insert' flag has NOT been set
        updateFlags.set( getRowPos(), new String( "U" ) );  // set the update flag for this row
    }

    if ( updateCols.containsKey( rowPos ) ) {
        colSet = (HashSet) updateCols.get( rowPos ); // get the cols hashtable for this row 
        colSet.add( new Integer( col ));  // add this column to the list of updated cols
    }
    else {                                                 // create the cols hashtable for this row
        colSet = new HashSet();
        colSet.add( new Integer( col ));  // add this column to the list of updated cols
        updateCols.put( rowPos, colSet ); // add to the updateCols Hashtable 
    }

    // set the object with designated value (update the object)
    setObject( col, value );

}
// ------------------------------------------------------------------
public boolean getInsertStatus( int row ) {

      if ( ( (String) updateFlags.get( row ) ).equals( "I" ) )
         return true;
      else
         return false;
}
// ------------------------------------------------------------------

// get the update status for a specific row and column
public boolean getUpdateStatus( int row, int col ) {
boolean retVal = false;

    // is this an 'insert' column ?
    if   ( ((String) updateFlags.get( row )).toString().equals("I") ) {
         retVal = true;                                  // all columns need 'updating' for inserts
    }

    // is this an 'update' column ? if so, then check the column for updates 
    if   ( ((String) updateFlags.get( row )).toString().equals("U") ) {

        // get the Hashset for this row 
        HashSet colSet = (HashSet) updateCols.get( new Integer( row ));

	// is this column in the HashSet ?
	retVal = colSet.contains( new Integer( col ) );
    }
  
  return retVal;
}


//public Object getUpdateFlag ( int row ) {
//       return updateFlags.get( row ); 
//}

// get the update status for the current row 
public boolean getUpdateStatus() { // get the update status for the current row 

     if ( ((String) updateFlags.get( getRowPos() )) != null ) { // then the 'update' flag has been set
        return true;
     }
     else {
        return false;
     }

}

// get the update status for a specific row 
public boolean getUpdateStatus(int row ) { // get the update status for a specific row 

     if ( ((String) updateFlags.get( row )) != null ) { // then the 'update' flag has been set
        return true;
     }
     else {
       return false;
     }

}

public int getRowCount() {

   return rowCount;

}

public int getColumnCount() {
   
   return columnCount;
}

public String getColumnName( int col ) {
    
   return (String) colNums.get( new Integer( col ) ); // column name must be String
}

public int getRowPos() {
  
   return currentRow;

}

// get the String value at the column offset 
public Object getObject( int col )  {

    return currentRecord.get( col );

}

// ------------------------------------------------------------------
 // get the String value at the column name position 
public Object getObject( String colName ) {
   
    int pos = ((Integer) colKeys.get( colName )).intValue();
    return getObject( pos ) ;

}

// ------------------------------------------------------------------
// positioning 
// move to the absolute postion 
public void absolute( int pos ) { 

    currentRow = pos;
    currentRecord = (Vector) rows.get( currentRow );

}

// move to the relative position 
public void relative( int pos ) { 

    currentRow += pos;
    currentRecord = (Vector) rows.get( currentRow );

}

// ------------------------------------------------------------------

public void dumpContents() {

System.out.println( "*********************************" );
System.out.println("Column Count: " + this.getColumnCount() );
System.out.println("Row Count: " + this.getRowCount() );

    for ( int n = 0; n < this.getRowCount(); n++ ) {
         this.absolute( n );
         System.out.println( "*********************************" );
         System.out.println( "Row: " + n );
         for ( int z = 0; z < this.getColumnCount(); z++ ) { 
              System.out.println( "Column Name: " + this.getColumnName( z ) + 
	                          " - Column Value: " + this.getObject( z ) );

	 }
    }

}
// --------------------------------------------------------------
// clears update flags ... does NOT reset data to pre-update state
public void clearUpdates() {

for ( int n = 0; n < getRowCount(); n++ )
     updateFlags.set( n, new String( "" ) );  // set the update flag for this row

}


// --------------------------------------------------------------
// clear internal counters and vectors and allow this object to be reused 
public void clear() {

// clear the vectors 
rows.removeAllElements();
updateFlags.removeAllElements();  
currentRecord.removeAllElements();

// need a new object reference for the Hashtables
colKeys    = new Hashtable();
colNums    = new Hashtable();
updateCols = new Hashtable();

currentRow    = 0;
rowCount      = 0;
columnCount   = 0;

}

}
