
/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */


package db;

import java.util.Vector;
import java.util.Hashtable;
import java.util.HashSet;
import java.util.Collection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

public class GeneralVO implements GenericVO {

private Vector    record   = new Vector();
private Hashtable colkeys  = new Hashtable();
private Hashtable colnames = new Hashtable();
private int       columnCount;

public static void main(String args[] ) {

try { 
   DBUtil dbutil = new DBUtil("moviesmysql");
   ResultSet rs = dbutil.executeDBQuery( "select * from users" );

   GeneralVO gvo = new GeneralVO();

   rs.next();
   gvo.setVO( rs );
   gvo.dump();

}
catch (Exception e) {

}

}



// retrieve contents -- get the String value at the column offset 
public Object getObject( int col ) {

return record.get( col );

}
// ---------------------------------------------------

// get the String value at the column name position 
public Object getObject( String colName ) {

return record.get( ((Integer ) colkeys.get( colName )).intValue() );

}

// ---------------------------------------------------

// set contents
public void setObject( int col, Object obj ) {
  record.set( col, obj );
}

// ---------------------------------------------------
public void setObject( String colName, Object obj ) {

record.set( ((Integer) colkeys.get( colName )).intValue(), obj );

}

// ---------------------------------------------------
// add contents
public void addObject( Object obj ) {

   record.add( obj );

}

// --------------------------------------------------
public void setColNames( ResultSet rs ) {
try {

  ResultSetMetaData rsmd = rs.getMetaData();

  for (int n = 1; n <= rsmd.getColumnCount(); n++) {
      colkeys.put( rsmd.getColumnName( n ), new Integer( n-1) ); 
      colnames.put( new Integer( n-1), rsmd.getColumnName( n ) ); 
  }
}
catch (SQLException e ) {
     System.out.println("SQLException in GeneralVO.setColNames: " + e.getMessage() );
}

}

// --------------------------------------------------

public void setColCount( ResultSet rs ) {

try {
   columnCount = rs.getMetaData().getColumnCount();
}
catch (SQLException e ) {
     System.out.println("SQLException in GeneralVO.setColCount: " + e.getMessage() );
}
}
// --------------------------------------------------

public void setVO( ResultSet rs ) {

try {
 ResultSetMetaData rsmd = rs.getMetaData();

System.out.println("colcount: " + rsmd.getColumnCount() );
 int columns = rsmd.getColumnCount();

  for (int n = 1; n <= columns; n++) {
      addObject( rs.getObject( n ) );
  }
  rs.beforeFirst();
  setColNames( rs );
  setColCount( rs );

}
catch (SQLException e) {
     System.out.println("SQLException in GeneralVO.setVO: " + e.getMessage() );
}

}
// ----------------------------------------------------

public Collection getVO () {
   return record;
}
// ----------------------------------------------------

public String getColumnName( int col ) {

   return (String) colnames.get( new Integer( col ) );
}

public Hashtable getColNames() {
   return colkeys;
}

// ----------------------------------------------------
public void dump() {

for (int n = 0; n < record.size();n++) {
     System.out.println("col number: " + n + " - " + " name: " + colnames.get( new Integer( n ) ) + 
                        " - value: " + record.get( n ) ); 
}

}


}
