
/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */
package db;

import java.sql.SQLException;

public interface GenericDO {

// will prepare and execute the quer 
public boolean executeQuery( String query ) throws SQLException; // returns true for success 

// will execute the previously prepared query 
public boolean executeQuery( ) throws SQLException; // returns true for success 

// positional update methods 
public void updateString( int col, String value ); // update string in column with value 

// internal updateable ResultSet manipulation 
public void updateRow( ) throws SQLException;     // apply the current row updates to the database 
public void cancelUpdates() throws SQLException;  // cancel any pending updates 

// set data 
public void setData( GenericVO vo ); // set the contents of the DO to the values of the VO passed 
public boolean update();             // update the contents of the DO to the database (all)

// get data 
public GenericVO  getData() throws SQLException;   // returns generic Value Object 

}
