
/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */


package db;

import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class StatusDAO {

DBUtil            dbutil;
PreparedStatement generalStatusQuery;

String statusQuery1;

public static void main( String args[] ){

StatusDAO sd = new StatusDAO( "knowledgebase" );

System.out.println("sd.getGeneralStatus: " + sd.getGeneralStatus() );


}

// ** constructor ** 
public StatusDAO( String dataSourceName ) {

try { 
   dbutil =  new DBUtil( dataSourceName );

   // get the query from an environment entry - don't hardcode it
   InitialContext ctx = new InitialContext();
   statusQuery1 = (String) ctx.lookup("java:comp/env/statusQuery1");

   prepareQueries();

}
catch (NamingException e) {
     System.err.println("NamingException in StatusDAO.constructor: " + e.getMessage() );
}

}


private void prepareQueries() {

try {

   generalStatusQuery = dbutil.createPreparedStatement( statusQuery1 ); 

}
catch (Exception e) {
     System.out.println("Exception in StatusDAO.prepareQueries: " + e.getMessage() + " - " + e );
}

}

public ResultSet getGeneralStatus( ) {
ResultSet rs = null;

 try { 

     rs =  generalStatusQuery.executeQuery();

    }
    catch (SQLException e ) {
         System.out.println("Exception caught in StatusDAO.getGeneralStatus: " + e.getMessage() );
    }
    finally {
         return rs;
    }

   }

}
