
/*
 * Copyright (c) 2002 Prentice Hall
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. 
 *
 * PRENTICE HALL MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. PRENTCE HALL SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * Author: Art Taylor  
 */


package movies.beans;

import java.rmi.*;
import javax.naming.*;
import javax.rmi.*;
import javax.ejb.*;
import java.util.*;

import db.*;
import movies.ejb.*;

public class MoviesBean extends MoviesVO {

InitialContext context;

MoviesEntityRemote movies;
MoviesEntityHome   moviesHome;


public MoviesBean() {

try { 
   Hashtable env = new Hashtable();
   
   // get a connection to the EJB server (JBoss) 
   env.put( "java.naming.factory.initial", "org.jnp.interfaces.NamingContextFactory");
   env.put( "java.naming.provider.url", "jnp://localhost:1099");
   env.put( "java.naming.factory.url.pkgs", "org.jboss.naming:org.jnp.interfaces");
   context = new InitialContext( env );
  
   //
   // get the movies entity bean 
   //
   moviesHome = (MoviesEntityHome) PortableRemoteObject.narrow( context.lookup("ejb/MoviesEntityBean"), 
                                                                MoviesEntityHome.class );
}
catch (NamingException e) {
      System.out.println("NamingException in MoviesBean constructor: " + e.getMessage() );
}
catch (Exception e) {
      System.out.println("Exception in MoviesBean constructor: " + e.getMessage() );
}

}

public void loadBean( String movie_id ) {

try {

 // lookup this movie_id 
 movies = moviesHome.findByPrimaryKey(new Integer( movie_id ));

// debug 
System.out.println("findByPrimaryKey succeeded ... "  );

 // set this object to look like the VO populated by the lookup
 // MoviesVO moviesVO = movies.getMoviesVO();
 MoviesVO vo = movies.getMoviesVO();

// debug 
System.out.println("moviesVO.getMovie_name: " + vo.getMovie_name() );

 setMoviesVO( vo );

}
catch (RemoteException e) {
      System.out.println("RemoteException in MoviesBean loadbean: " + e.getMessage() );
}
catch (FinderException e) {
      System.out.println("FinderException in MoviesBean loadbean: " + e.getMessage() );
}
catch (Exception e) {
      System.out.println("Exception in MoviesBean loadbean: " + e.getMessage() + " - " + e  );
}
catch (Throwable e) {
      System.out.println("Exception in MoviesBean loadbean: " + e.getMessage() + " - " + e  );
}

}

//public MoviesVO getMoviesVO() {
//MoviesVO moviesVO = null;
//
//try { 
//     moviesVO = movies.getMoviesVO();
// }
//catch (RemoteException e) {
//      System.out.println("RemoteException in MoviesBean constructor: " + e.getMessage() );
//}
//
//finally {
//  return moviesVO;
//}
//}

}
