package servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Hashtable;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.StringReader;
import java.io.Serializable;
import java.net.URL;
import java.net.MalformedURLException;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import com.icl.saxon.trax.Result;
import com.icl.saxon.trax.Processor;
import com.icl.saxon.trax.Templates;
import com.icl.saxon.trax.Transformer;
import com.icl.saxon.trax.ProcessorException;
import com.icl.saxon.trax.ProcessorFactoryException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.rmi.RemoteException;
import javax.rmi.PortableRemoteObject;
import javax.ejb.CreateException;
import movies.ejb.MoviesFacadeHome;
import movies.ejb.MoviesFacadeRemote;

public class ServletExample2 extends HttpServlet {

private MoviesFacadeRemote moviesEJB;

//
// for Saxon XML transformations
//
private Processor   processor;
private Templates   templates;
private Transformer transformer;

private String  defaultStyleSheet = "file:/lin/home/art/JDBC_Real/Code/Dynamic/rs.xsl";


    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
        PrintWriter out = response.getWriter();

        out.println("<html>");
        out.println("<head>");

	out.println("<title>ServletExample2</title>");
        out.println("</head>");
        out.println("<body bgcolor=\"white\">");

        try { 

          //
	  // retrieve the query results as an XML document 
	  // 
	  String xmlDoc = getQueryResults();

          //
          // transform the XML to the format for our output (an HTML table)
	  //
	  Transformer transformer = templates.newTransformer();
          transformer.transform(  new InputSource( new StringReader( xmlDoc ) ),
	                          new Result( out ) ); 
	  

           out.println("</body>");
           out.println("</html>");
        }
	catch (Exception e) { 
              log( "Exception in doGet: " + e.getMessage() );
	}
      
      }

public String getQueryResults() {
String retVal = null;
try {
     retVal = moviesEJB.getHelpDeskStatus(); 
}
catch (RemoteException e) {
       log("RemoteException in ServletExample2.getQueryResults: " + e.getMessage() );
}
finally {
  return retVal;
}

}


public void init( ) {

Hashtable env = new Hashtable();

	  //
	  // get the location of the xslt stylesheet from a context parameter
	  //
	  String styleSheet = getInitParameter( "XsltStyleSheet" );

try {
	  //
	  // build the URL for the stylesheet 
	  //
	  if ( styleSheet == null ) 
	      styleSheet = defaultStyleSheet;
          else
	      styleSheet = "file:" + styleSheet;

          // 
	  // create the objects we need for the XSL transformation 
	  //
	  processor = Processor.newInstance("xslt");
          //
	  // Get an InputStream from the URL 
	  // Does InputSource constructor support URL encoded string ?? 
          //
	  templates = processor.process(new InputSource( 
	                  new URL( styleSheet ).openStream() ) );

	  transformer = templates.newTransformer();

         //
         // Get a connection to the EJB server 
	 //
	 env.put( "java.naming.factory.initial", getInitParameter( "java.naming.factory.initial" ) );
	 env.put( "java.naming.provider.url",    getInitParameter( "java.naming.provider.url" ) );
	 env.put( "java.naming.factory.pkgs",    getInitParameter( "java.naming.factory.url.pkgs" ) );

         InitialContext init = new InitialContext( env );

         MoviesFacadeHome home = (MoviesFacadeHome) PortableRemoteObject.narrow( init.lookup("ejb/MoviesFacade"),   
  	                          MoviesFacadeHome.class );

         moviesEJB = home.create();

}
catch (ProcessorException e) {
       log("ProcessorException in ServletExample2.init: " + e.getMessage() );
}
catch (NamingException e) {
       log("NamingException in ServletExample2.init: " + e.getMessage() + " - " + e );
}
catch (SAXException e) {
       log("SAXException in ServletExample2.init: " + e.getMessage() + " - " + e );
}
catch (RemoteException e) {
       log("RemoteException in ServletExample2.init: " + e.getMessage() + " - " + e );
}
catch (MalformedURLException e) {
       log("MalformedURLException in ServletExample2.init: " + e.getMessage() + " - " + e );
}
catch (IOException e) {
       log("IOException in ServletExample2.init: " + e.getMessage() + " - " + e );
}
catch (CreateException e) {
       log("CreateException in ServletExample2.init: " + e.getMessage() + " - " + e );
}


}


}

